kdecore Library: KTempFile Class Reference (kdecore Library)

| # kdecore Library API Documentation
Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Namespaces | Source Files

# KTempFile Class Reference

The KTempFile class creates and opens a unique file for temporary use. More...

`#include <ktempfile.h>`

Collaboration diagram for KTempFile:

[legend]
List of all members.

## Public Member Functions
| KTempFile (QString filePrefix=QString::null, QString fileExtension=QString::null, int mode=0600)
| ~KTempFile ()
void | setAutoDelete (bool autoDelete)
int | status () const
QString | name () const
int | handle () const
FILE * | fstream ()
QTextStream * | textStream ()
QDataStream * | dataStream ()
QFile * | file ()
void | unlink ()
bool | sync ()
bool | close ()
## Protected Member Functions
| KTempFile (bool)
bool | create (const QString &filePrefix, const QString &fileExtension, int mode)
void | setError (int error)
## Friends
class | KSaveFile

## Detailed Description

The KTempFile class creates and opens a unique file for temporary use.

This is especially useful if you need to create a file in a world writable directory like /tmp without being vulnerable to so called symlink attacks.

KDE applications, however, shouldn't create files in /tmp in the first place but use the "tmp" resource instead. The standard KTempFile constructor will do that by default.

To create a temporary file that starts with a certain name in the "tmp" resource, one should use: KTempFile(locateLocal("tmp", prefix), extension);

KTempFile does not create any missing directories, but locateLocal() does.

See also KStandardDirs

Author:
  Waldo Bastian <bastian@kde.org>

Definition at line 55 of file ktempfile.h.

## Constructor & Destructor Documentation

KTempFile::KTempFile | ( | QString | filePrefix = `QString::null`,
|  | QString | fileExtension = `QString::null`,
|  | int | mode = `0600`
| ) |

  | Creates a temporary file with the name: <filePrefix><six letters><fileExtension>. The default `filePrefix` is "$KDEHOME/tmp-$HOST/appname/" The default `fileExtension` is ".tmp" Parameters:
  | filePrefix | the prefix of the file name, or QString::null for the default value
  | fileExtension | the extension of the prefix, or QString::null for the default value
  | mode | the file permissions
Definition at line 60 of file ktempfile.cpp. References QString::isEmpty().

KTempFile::~KTempFile | ( |  | ) |

| The destructor closes the file. If autoDelete is enabled the file gets unlinked as well. Definition at line 129 of file ktempfile.cpp. References close(), and unlink().

KTempFile::KTempFile | ( | bool |  | ) | `[protected]`

| Constructor used by KSaveFile. Definition at line 79 of file ktempfile.cpp.

## Member Function Documentation

void KTempFile::setAutoDelete | ( | bool | autoDelete | ) | `[inline]`

  | Turn automatic deletion on or off. Automatic deletion is off by default. Parameters:
  | autoDelete | true to turn automatic deletion on
Definition at line 87 of file ktempfile.h.

int KTempFile::status | ( |  | ) | const

| Returns the status of the file based on errno. (see errno.h) 0 means OK. You should check the status after object creation to check whether a file could be created in the first place. You may check the status after closing the file to verify that the file has indeed been written correctly. Returns: the errno status, 0 means ok Definition at line 137 of file ktempfile.cpp.

QString KTempFile::name | ( |  | ) | const

| Returns the full path and name of the file. Note that in most circumstances the file needs to be closed before you use it by name. In particular, if another process or software part needs to write data to the file based on the filename, the file should be closed before doing so. Otherwise the act of closing the file later on may cause the file to get truncated to a zero-size, resulting in an unexpected loss of the data. In some cases there is only interest in the filename itself but where the actual presence of a file with such name is a problem. In that case the file should first be both closed and unlinked. Such usage is not recommended since it may lead to the kind of symlink vulnerabilities that the KTempFile design attempts to prevent. Returns: The name of the file, or QString::null if opening the file has failed or the file has been unlinked already. Definition at line 143 of file ktempfile.cpp. Referenced by KSaveFile::close(), and file().

int KTempFile::handle | ( |  | ) | const

| An integer file descriptor open for writing to the file. Returns: The file descriptor, or a negative number if opening the file failed Definition at line 149 of file ktempfile.cpp. Referenced by KSaveFile::close(), and KSaveFile::KSaveFile().

FILE * KTempFile::fstream | ( |  | ) |

| Returns the FILE* of the temporary file. Returns: FILE* stream open for writing to the file, or 0 if opening the file failed Definition at line 155 of file ktempfile.cpp. References QString::latin1(). Referenced by file().

QTextStream * KTempFile::textStream | ( |  | ) |

| Returns the QTextStream for writing. Returns: QTextStream open for writing to the file, or 0 if opening the file failed Definition at line 182 of file ktempfile.cpp. References file().

QDataStream * KTempFile::dataStream | ( |  | ) |

| Returns a QDataStream for writing. Returns: QDataStream open for writing to the file, or 0 if opening the file failed Definition at line 192 of file ktempfile.cpp. References file().

QFile * KTempFile::file | ( |  | ) |

| Returns a QFile. Returns: A QFile open for writing to the file, or 0 if opening the file failed. Definition at line 170 of file ktempfile.cpp. References fstream(), name(), QFile::open(), and QFile::setName(). Referenced by dataStream(), and textStream().

void KTempFile::unlink | ( |  | ) |

| Unlinks the file from the directory. The file is deleted once the last reader/writer closes it. Definition at line 202 of file ktempfile.cpp. References QString::isEmpty(), and QFile::remove(). Referenced by KSaveFile::abort(), KSaveFile::close(), and ~KTempFile().

bool KTempFile::sync | ( |  | ) |

| Flushes file to disk (fsync). If you want to be as sure as possible that the file data has actually been physically stored on disk you need to call sync(). See status() for details about errors. Returns: true if successful, or false if an error has occurred. Since: 3.3 Definition at line 216 of file ktempfile.cpp. References QString::latin1(). Referenced by KSaveFile::close().

bool KTempFile::close | ( |  | ) |

| Closes the file. See status() for details about errors. Returns: true if successful, or false if an error has occurred. Definition at line 250 of file ktempfile.cpp. References QString::latin1(). Referenced by KSaveFile::abort(), KSaveFile::close(), and ~KTempFile().

The documentation for this class was generated from the following files:

- ktempfile.h
- ktempfile.cpp

This file is part of the documentation for kdecore Library Version 3.4.1.
Documentation copyright © 1996-2004 the KDE developers.
Generated on Sat Jun 11 20:19:09 2005 by doxygen 1.4.1 written by Dimitri van Heesch, © 1997-2003